/*
 * vars.h: header for vars.c
 *
 * Generated from vars.h.proto automatically by the Makefile
 *
 * @(#)$Id: vars.h.proto,v 1.14.2.2 1995/11/01 12:16:45 mrg Exp $
 */

#ifndef __vars_h_
#define __vars_h_

enum CVAR_TYPES {
	AINV_CVAR,
	AUTO_REJOIN_CVAR,
	DEOPFLOOD_CVAR,
	DEOPFLOOD_TIME_CVAR,
	DEOP_ON_DEOPFLOOD_CVAR,
	DEOP_ON_KICKFLOOD_CVAR,
	HACKING_CVAR,
	KICK_IF_BANNED_CVAR,
	KICK_ON_DEOPFLOOD_CVAR,
	KICK_ON_KICKFLOOD_CVAR,
	KICK_ON_NICKFLOOD_CVAR,
	KICK_ON_PUBFLOOD_CVAR,
	KICKFLOOD_CVAR,
	KICKFLOOD_TIME_CVAR,
	LAMELIST_CVAR,
	NICKFLOOD_CVAR,
	NICKFLOOD_TIME_CVAR,
	PUBFLOOD_CVAR,
	PUBFLOOD_TIME_CVAR,
	SHITLIST_CVAR,
	USERLIST_CVAR,
NUMBER_OF_CVARIABLES,
};
/* indexes for the irc_variable array */

enum VAR_TYPES {
	AINV_VAR,
	ALWAYS_SPLIT_BIGGEST_VAR ,
	ANNOY_KICK_VAR ,
	AOP_VAR ,
	AUTOCK_VAR ,
	AUTO_NSLOOKUP_VAR ,
	AUTO_REJOIN_VAR ,
	AUTO_UNMARK_AWAY_VAR ,
	AUTO_WHOWAS_VAR  ,
	BEEP_VAR ,
	BEEP_MAX_VAR ,
	BEEP_ON_MSG_VAR ,
	BEEP_WHEN_AWAY_VAR ,
	BOLD_VIDEO_VAR ,
	BOT_MODE_VAR ,
	CHANNEL_NAME_WIDTH_VAR ,
	CHECK_BEEP_USERS_VAR ,
	CLIENTINFO_VAR ,
	CLOAK_VAR ,
	CLOCK_VAR ,
	CLOCK_24HOUR_VAR ,
	CLOCK_ALARM_VAR ,
	CMDCHARS_VAR ,
	COMMAND_MODE_VAR ,
	COMMENT_BREAKAGE_VAR,
	CONTINUED_LINE_VAR ,
	CTCP_FLOOD_PROTECTION_VAR ,
	CTOOLZ_DIR_VAR ,
	DCC_AUTOGET_VAR ,
	DCC_BLOCK_SIZE_VAR,
	DCC_DLDIR_VAR , 
	DCC_GET_LIMIT_VAR,
	DCC_SEND_LIMIT_VAR,
	DCC_QUEUE_LIMIT_VAR,
	DEBUG_VAR ,
	DEFAULT_REASON_VAR ,
	DEOPFLOOD_VAR ,
	DEOPFLOOD_TIME_VAR,
	DEOP_ON_DEOPFLOOD_VAR,
	DEOP_ON_KICKFLOOD_VAR,
	DISPLAY_VAR ,
	DISPLAY_ANSI_VAR,
	EGO_VAR ,
	EIGHT_BIT_CHARACTERS_VAR,
	ENCRYPT_PROGRAM_VAR ,
	EXEC_PROTECTION_VAR ,
	FAKE_HOST_VAR , 
	FAKEIGNORE_VAR ,
	FLOATING_POINT_MATH_VAR,
	FLOOD_AFTER_VAR ,
	FLOOD_KICK_VAR ,
	FLOOD_PROTECTION_VAR ,
	FLOOD_RATE_VAR ,
	FLOOD_USERS_VAR ,
	FLOOD_WARNING_VAR ,
	FULL_STATUS_LINE_VAR ,
	HACKING_VAR ,
	HACKPASS_VAR ,
	HARD_UH_NOTIFY_VAR ,
	HELP_PAGER_VAR ,
	HELP_PATH_VAR ,
	HELP_PROMPT_VAR ,
#ifdef OLD_CRUD
	HELP_SERVICE_VAR ,
#endif
	HELP_WINDOW_VAR ,
	HIDE_PRIVATE_CHANNELS_VAR ,
	HIGHLIGHT_CHAR_VAR ,
	HISTORY_VAR ,
	HISTORY_FILE_VAR ,
	HOLD_MODE_VAR ,
	HOLD_MODE_MAX_VAR ,
	IDLE_CHECK_VAR,
	INDENT_VAR ,
	INPUT_ALIASES_VAR ,
	INPUT_PROMPT_VAR ,
	INPUT_PROTECTION_VAR ,
	INSERT_MODE_VAR ,
	INVERSE_VIDEO_VAR ,
	KICK_IF_BANNED_VAR ,
	KICK_ON_DEOPFLOOD_VAR ,
	KICK_ON_KICKFLOOD_VAR ,
	KICK_ON_NICKFLOOD_VAR ,
	KICK_ON_PUBFLOOD_VAR ,
	KICK_OPS_VAR ,
	KICKFLOOD_VAR ,
	KICKFLOOD_TIME_VAR ,
	KILLLOGFILE_VAR ,
	LAMELIST_VAR ,
	LASTLOG_VAR ,
	LASTLOG_LEVEL_VAR ,
	LLOOK_VAR ,
	LLOOK_DELAY_VAR ,
	LOAD_PATH_VAR ,
	LOG_VAR ,
	LOGFILE_VAR ,
	LONG_MSG_VAR ,
	MAIL_VAR ,
	MAX_AUTOGET_SIZE_VAR ,
	MAX_DEOPS_VAR ,
	MAX_IDLEKICKS_VAR ,
	MAX_RECURSIONS_VAR ,
	MENU_VAR ,
	MODE_STRIPPER_VAR ,
	MSGCOUNT_VAR, 
	MSGLOG_VAR ,
	MSGLOGFILE_VAR ,
	NEXT_SERVER_ON_LOCAL_KILL_VAR,
	NICKFLOOD_VAR,
	NICKFLOOD_TIME_VAR,
	NO_CTCP_FLOOD_VAR,
	NOTIFY_HANDLER_VAR,
	NOTIFY_LEVEL_VAR,
	NOTIFY_ON_TERMINATION_VAR,
	NOVICE_VAR,
	NUM_BANMODES_VAR,
	NUM_OPMODES_VAR,
	PAD_CHAR_VAR,
	PING_TYPE_VAR,
	PROTECT_CHANNELS_VAR,
	PUBFLOOD_VAR,
	PUBFLOOD_TIME_VAR,
	PUB_LOGSTR_VAR,
	REALNAME_VAR,
	REASONFILE_VAR,
	REASON_TYPE_VAR,
	REVERSE_STATUS_LINE_VAR,
	SAME_WINDOW_ONLY_VAR,
	SAVEFILE_VAR,
	SCREEN_OPTIONS_VAR,
	SCROLL_VAR,
	SCROLL_LINES_VAR,
	SEND_AWAY_MSG_VAR,
	SEND_IGNORE_MSG_VAR,
	SHELL_VAR,
	SHELL_FLAGS_VAR,
	SHELL_LIMIT_VAR,
	SHITLIST_VAR,
	SHITLIST_REASON_VAR,
	SHOW_AWAY_ONCE_VAR,
	SHOW_CHANNEL_NAMES_VAR,
	SHOW_CTCP_IDLE_VAR,
	SHOW_END_OF_MSGS_VAR,
	SHOW_FAKES_VAR,
	SHOW_NUMERICS_VAR,
	SHOW_SERVER_CRAP_VAR,
	SHOW_SERVER_KILLS_VAR,
	SHOW_STATUS_ALL_VAR,
	SHOW_TOOMANY_VAR,
	SHOW_UNAUTHS_VAR,
	SHOW_WHO_HOPCOUNT_VAR,
	STATUS_AWAY_VAR,
	STATUS_CHANNEL_VAR,
	STATUS_CHANOP_VAR,
	STATUS_CLOCK_VAR,
	STATUS_FORMAT_VAR,
	STATUS_FORMAT1_VAR,
	STATUS_FORMAT2_VAR,
	STATUS_HOLD_VAR,
	STATUS_HOLD_LINES_VAR,
	STATUS_INSERT_VAR,
	STATUS_MAIL_VAR,
	STATUS_MODE_VAR,
	STATUS_NOTIFY_VAR,
	STATUS_OPER_VAR,
	STATUS_OVERWRITE_VAR,
	STATUS_QUERY_VAR,
	STATUS_SERVER_VAR,
	STATUS_UMODE_VAR,
	STATUS_USER_VAR,
	STATUS_USER1_VAR,
	STATUS_USER2_VAR,
	STATUS_USER3_VAR,
	STATUS_USER4_VAR,
	STATUS_USER5_VAR,
	STATUS_USER6_VAR,
	STATUS_USER7_VAR,
	STATUS_USER8_VAR,
	STATUS_USER9_VAR,
	STATUS_WINDOW_VAR,
	SUPPRESS_SERVER_MOTD_VAR,
	TAB_VAR,
	TAB_MAX_VAR,
	TRANSLATION_VAR,
	UNDERLINE_VIDEO_VAR,
	USE_FAKE_HOST_VAR,
	USER_INFO_VAR,
#define USERINFO_VAR USER_INFO_VAR
	USERLIST_VAR,
	VERBOSE_CTCP_VAR,
	WALLOP_MSG_VAR,
	WARN_OF_IGNORES_VAR,
	XTERM_OPTIONS_VAR,
NUMBER_OF_VARIABLES,
};

	int	do_boolean _((char *, int *));
	void	set_variable _((char *, char *, char *));
	int	get_int_var _((enum VAR_TYPES));
	char	*get_string_var _((enum VAR_TYPES));
	void	set_int_var _((enum VAR_TYPES, unsigned int));
	void	set_string_var _((enum VAR_TYPES, char *));
	void	init_variables _((void));
	char	*make_string_var _((char *));
	void	set_highlight_char _((char *));
	int	charset_size _((void));
	void	save_variables _((FILE *, int));
	void	set_var_value _((int, char *));
	void    save_set _((FILE *));

extern	char	*var_settings[];
extern	int	loading_global;
	int cget_int_var _((enum CVAR_TYPES, char *));

/* var_settings indexes ... also used in display.c for highlights */
#define OFF 0
#define ON 1
#define TOGGLE 2

#define	DEBUG_COMMANDS		0x0001
#define	DEBUG_EXPANSIONS	0x0002
#define DEBUG_FUNCTIONS		0x0004

#endif /* __vars_h_ */
