/*
 *   CDE created userlist functions.
 *   Copyright Colten Edwards 04/10/96
 *
 */
 
#include "irc.h"
#include "server.h"
#include "edit.h"
#include "crypt.h"
#include "vars.h"
#include "ircaux.h"
#include "lastlog.h"
#include "window.h"
#include "screen.h"
#include "whois.h"
#include "hook.h"
#include "input.h"
#include "ignore.h"
#include "keys.h"
#include "names.h"
#include "alias.h"
#include "history.h"
#include "funny.h"
#include "ctcp.h"
#include "dcc.h"
#include "translat.h"
#include "output.h"
#include "exec.h"
#include "notify.h"
#include "numbers.h"
#include "status.h"
#include "list.h"
#include "struct.h"
#include "timer.h"
#include "pluto.h"
#include "bot.h"
#include "whowas.h"
#include "userlist.h"
#include <sys/stat.h>


/*
 *  Shit levels
 *  1 no opz
 *  2 Auto Kick
 *  3 Auto Ban Kick
 *  4 perm ban. all times.
 *
 *  User levels
 *  25 ctcp invite and whoami
 *  50 ops, chops and unban
 *  90 no Kick/Dop flood checking
 *
 *  Auto-op levels
 *  0 auto-op off
 *  1 timed autoop
 *  2 instant op
 *
 *  Protection levels
 *  1 Reop if de-oped
 *  2 De-op offender
 *  3 Kick  offender
 *  4 KickBan offender
 */

#define SHITLIST_ADD 11
#define SHITLIST_REMOVE 12
#define USERLIST_ADD 13
#define USERLIST_REMOVE 14
#define USERLIST_MOD 15

int user_count = 0;
int shit_count = 0;
extern char *FromUserHost;
extern char *awaymsg;

UserList *user_list;
ShitList *shitlist_list;
LameList *lame_list;
extern AJoinList *ajoin_list;

extern void save_idle _((FILE *output));



void prepare_userhost(stuff, nick, args)
WhoisStuff *stuff;
char *nick, *args;
{
	char listbuf[BIG_BUFFER_SIZE+1];
	char *uh;
	int thetype = 0;
	int level = 0, autoop = 0, prot = 0, shit = 0;
	char *channels = NULL, *passwd = NULL, *p = NULL;
	
        if (!stuff || !stuff->nick || !nick || !strcmp(stuff->user, "<UNKNOWN>") || my_stricmp(stuff->nick, nick))
        {
                say("No match for user %s", nick);
                return;
        }

	thetype = atoi(args);

	uh = stuff->user;
	if (*uh == '~' )
		uh++;
	if (*uh == '#')
		uh++;

	if (!(thetype % 2))
	    sprintf(listbuf, "*%s@%s", uh, stuff->host);
	else 
	{
		sprintf(listbuf, "*%s@%s", uh, cluster(stuff->host));
		p = next_arg(args, &args);
		p = next_arg(args, &args);
		level = atoi(p);
		p = next_arg(args, &args);
		autoop = atoi(p);
		p = next_arg(args, &args);
		prot = atoi(p);
		p = next_arg(args, &args);
		shit = atoi(p);
		if (strchr(args, ' ')) {
			p = next_arg(args, &args);
			malloc_strcpy(&channels, p);
			malloc_strcpy(&passwd, args);
		}else malloc_strcpy(&channels, args);
	}
	add_to_a_list(listbuf, thetype, stuff->nick, level, autoop, prot, channels, passwd, shit);
	if (thetype == USERLIST_ADD)
	{
		send_to_server("NOTICE %s :You have been added to my Userlist with a %d level", nick, level);
		send_to_server("NOTICE %s :you will %s auto-op'd", nick, autoop ? "be": "not be");
		send_to_server("NOTICE %s :you are %sprotected", nick, prot ? "": "not ");
	}
}

void add_user(char *command, char *args, char *subargs) 
{
	char *nick, *ptr;
	int level = 40, autoop = 0, prot = 0;
	char *passwd = NULL;
	char *channels = NULL;
	char *p = NULL; char * bang; char *temp = NULL;
	int type = USERLIST_ADD;
	
	if (command && *command && (my_stricmp(command,"UNUSER") == 0))
		type = USERLIST_REMOVE; 

	if (args && *args)
	{

		nick = next_arg(args, &args);
		if (!nick || !*nick) {
			return;
		}
		ptr = next_arg(args, &args);
		if (!ptr || !*ptr) {
			bitchsay("Need a channel for AddUser");
			return;
		}
		malloc_strcpy(&channels, ptr);

		ptr = next_arg(args, &args);
		if (ptr && *ptr)
			level = atoi(ptr);
	
		ptr = next_arg(args, &args);
		if (ptr && *ptr)
			autoop = atoi(ptr);

		ptr = next_arg(args, &args);
		if (ptr && *ptr)
			prot = atoi(ptr);

		ptr = next_arg(args, &args);
		if (ptr && *ptr)
			malloc_strcpy(&passwd, ptr);

		if ((bang = strchr(nick, '!')) && strchr(nick, '@'))
		{
			malloc_strcpy(&temp, nick);
			p = temp;
			bang = strchr(temp, '!');
			*bang++ = '\0';
			add_to_a_list(bang, type, p, level, autoop, prot, channels, passwd, 0);
			new_free(&p);
		}
		else
			if (passwd)
				add_to_userhost_queue(nick, prepare_userhost, "%d %d %d %d 0 %s %s", type, level, autoop, prot, channels, passwd);
			else
				add_to_userhost_queue(nick, prepare_userhost, "%d %d %d %d 0 %s", type, level, autoop, prot, channels);
	} else
		bitchsay("%s <nick or filter> <channel filter> <level> <aop> [<prot_level>] [<password>]", (command && *command)? command: "AddUser");
}


void add_shit(char *command, char *args, char *subargs) 
{
	char *nick, *ptr;
	int level = 1;
	char *reason = NULL;
	char *channels = NULL;
	char *p = NULL; char * bang; char *temp = NULL;

	int type = SHITLIST_ADD;
	
	if (command && *command && (my_stricmp(command, "UNSHIT")==0))
		type = SHITLIST_REMOVE;
	if (args && *args)
	{

		nick = next_arg(args, &args);
		if (!nick || !*nick) {
			return;
		}
		ptr = next_arg(args, &args);
		if (!ptr || !*ptr) {
			bitchsay("Need a channel for %s",command ? "UnShit": "AddShit");
			return;
		}
		malloc_strcpy(&channels, ptr);

		ptr = next_arg(args, &args);
		if (ptr && *ptr)
			level = atoi(ptr);

		if (args && *args)
			malloc_strcpy(&reason, args);
		else
			malloc_strcpy(&reason, "ShitListz");


		if ((bang = strchr(nick, '!')) && strchr(nick, '@'))
		{
			malloc_strcpy(&temp, nick);
			p = temp;
			bang = strchr(temp, '!');
			*bang++ = '\0';
			add_to_a_list(bang, type, p, 0, 0, 0, channels, reason, level);
			new_free(&p);
		}
		else
			add_to_userhost_queue(nick, prepare_userhost, "%d %d %d %d %d %s %s", type, 0, 0, 0, level, channels, reason);
		new_free(&reason);
	} else
		bitchsay("%s <nick or filter> <channel filter> <level> <reason>",(command && *command) ? command: "AddShit");
}

void add_to_a_list(thestring, thetype, nick, level, autoop, prot, channels, passwd, shitlevel)
char *thestring;
int thetype;
char *nick;
int level;
int autoop;
int prot;
char *channels;
char *passwd;
int shitlevel;
{
	void **TheList = NULL;
	UserList *uremove = NULL;
	ShitList *sremove = NULL;
	char which[16];
	char *theuh = NULL;
	
	switch (thetype)
	{
		case SHITLIST_ADD:
		case SHITLIST_REMOVE:
			TheList = (void *)&shitlist_list;
			strcpy(which, "Shit");
			break;
		case USERLIST_ADD:
		case USERLIST_REMOVE:
		case USERLIST_MOD:
			TheList = (void *)&user_list;
			strcpy(which, "User");
			break;
		default:
			bitchsay("Error!! Something FUCKED UP somewhere, thetype was unknown in add_to_a_list(%d)", thetype);
			return;
	}
	switch(thetype)
	{
		case USERLIST_ADD:
		case USERLIST_MOD:
			if (!(uremove = nickinuser(nick, thestring)))
			{
				user_count++;
				uremove = (UserList *) new_malloc(sizeof(UserList));
				uremove->level = level;
				uremove->aop = autoop;
				uremove->prot = prot;
				malloc_strcpy(&uremove->channels, channels);
				malloc_strcpy(&uremove->password, passwd);
				malloc_strcpy(&uremove->nick, nick);
				malloc_strcpy(&uremove->host, thestring);
				add_to_list((List **)TheList, (List *)uremove);
				sync_whowas_adduser(uremove);
			}
			break;
		case USERLIST_REMOVE:
			if ((uremove = (UserList *)removewild_from_list((List **)TheList, nick)) != NULL) 
			{
				if (wild_match(uremove->host, thestring) || wild_match(thestring, uremove->host))
				{
					user_count--;
					sync_whowas_unuser(uremove);
					new_free(&uremove->host);
					new_free(&uremove->nick);
					new_free(&uremove->password);
					new_free(&uremove->channels);
				} 
				else
				{
					add_to_list((List **)&user_list, (List *)uremove);
					uremove = NULL;
				}
			}
			break;
		case SHITLIST_ADD:
			if (!(sremove = nickinshit(nick, thestring)))
			{
				shit_count++;
				sremove = (ShitList *) new_malloc(sizeof(ShitList));
				sremove->level = shitlevel;
				malloc_strcpy(&sremove->reason, passwd);
				malloc_strcpy(&sremove->channels, channels);
				malloc_sprintf(&sremove->filter, "*!%s", thestring);
				add_to_list((List **)TheList, (List *)sremove);
				sync_whowas_addshit(sremove);
			}
			break;
		case SHITLIST_REMOVE:
			if ((sremove = (ShitList *)removewild_from_list((List **)TheList, nick)) != NULL) 
			{
				malloc_sprintf(&theuh, "%s!%s", nick, thestring);
				if (wild_match(sremove->filter, theuh) || wild_match(theuh, sremove->filter))
				{
					shit_count--;
					sync_whowas_unshit(sremove);
					new_free(&sremove->filter);
					new_free(&sremove->reason);
					new_free(&sremove->channels);
				} 
				else
				{
					add_to_list((List **)&TheList, (List *)sremove);
					sremove = NULL;
				}
				new_free(&theuh);
			}
			break;
		default:
			break;
	}	

	if (uremove || sremove)
	{
		if ((thetype == USERLIST_ADD) || (thetype == SHITLIST_ADD))
			bitchsay("Adding %s!%s to %s list", nick, thestring, which);
		else if (thetype == USERLIST_MOD)
			bitchsay("Modified %s!%s on %s list", nick, thestring, which);
		else if (thetype == SHITLIST_REMOVE || (thetype == USERLIST_REMOVE))
		{
			bitchsay("Deleting %s!%s from %s list", nick, thestring, which);
			if (thetype == SHITLIST_REMOVE)
				new_free((char **)&sremove);
			else
				new_free((char **)&uremove);
		}
	} 
	else
	{
		if ((thetype == USERLIST_ADD) || (thetype == SHITLIST_ADD))
			bitchsay ("%s!%s already on my %s list", nick,thestring, which);
		else
			bitchsay("Didnt find %s!%s on %s list", nick, thestring, which);
	}
}

void showuserlist(char *command, char *args, char *subargs)
{
	UserList *tmp = user_list;
	int first = 0;
	if (!tmp)
	{
		bitchsay("No entries in User list");
		return;
	}
	while (tmp)
	{
		if (do_hook(USERLIST_LIST, "%d %d %d %s %s %s %s", tmp->level, tmp->aop, tmp->prot,tmp->nick,tmp->host,tmp->channels,tmp->password?tmp->password:""))
		{
			if (!first)
				put_it("level aop prot  nick       password     host                      channels");           
			first++;
			put_it(" %-03d   %-04d %-03d %-10s %-10s %-25s %s", 
				tmp->level, tmp->aop, tmp->prot, 
				tmp->nick, tmp->password?tmp->password:"<none>", 
				tmp->host, tmp->channels);
		}
		tmp = tmp->next;
	}
	if (first)
		bitchsay("End of User list");
}

void showshitlist(char *command, char *args, char *subargs)
{
	ShitList *tmp = shitlist_list;
	int first = 0;
	if (!tmp)
	{
		bitchsay("No entries in Shit list");
		return;
	}
	while (tmp)
	{
		if (do_hook(SHITLIST_LIST, "%d %s %s %s %s %s", tmp->level, tmp->filter,tmp->channels, tmp->reason?tmp->reason:"<none>", "", ""))
		{
			if (!first)
				put_it(" lvl nick                               channels   reason");
			put_it("  %-02d %-34s %-10s %s", tmp->level,
					  tmp->filter, tmp->channels,  
					  tmp->reason?tmp->reason:"<No Reason>"); 
			first++;
		}
		tmp = tmp->next;
	}
	if (first)
		bitchsay("%d entries in Shit List",shit_count);
}

void set_user_info(char *command, char *args, char *subargs)
{

}

int check_channel_match(char *tmp, char *channel)
{
	char *p, *q, *chan = NULL;
	int match = 0;
	if (!tmp || !channel)
		return 0;
	if ((strchr(tmp, ',')))
	{
		malloc_strcpy(&chan, tmp);
		p = q = chan;
		while(chan && (p = strchr(chan, ',')))
		{
			*p = '\0';
			if ((match = wild_match(chan, channel)))
				break;
			chan = ++p;
		}
		if (!match)
			match = wild_match(chan, channel);
		new_free(&q);
	} 
	else
		match = wild_match(tmp, channel);
	return match;
}

UserList *nickinuser(char *niq, char *uh)
{
	char *theuh;
	UserList *thisptr = user_list;

	if (!uh || !niq)
		return NULL;
	theuh = (char *) new_malloc(strlen(niq)+strlen(uh)+4);
	sprintf(theuh, "*%s", uh);
	while (thisptr)
	{
		if (!thisptr->host)
			continue;
		if (wild_match(theuh, thisptr->host) || wild_match(thisptr->host, theuh)) {
			new_free(&theuh);
			return(thisptr);
		}
		thisptr = thisptr->next;
	}
	new_free(&theuh);
	return NULL;
}

UserList *nickinbot(char *niq, char *uh)
{
	char *theuh;
	UserList *thisptr = Bot_list;

	if (!uh || !niq)
		return NULL;
	theuh = (char *) new_malloc(strlen(niq)+strlen(uh)+4);
	sprintf(theuh, "*%s", uh);
	while (thisptr)
	{
		if (!thisptr->host)
			continue;
		if (wild_match(theuh, thisptr->host) || wild_match(thisptr->host, theuh)) {
			new_free(&theuh);
			return(thisptr);
		}
		thisptr = thisptr->next;
	}
	new_free(&theuh);
	return NULL;
}

ShitList *nickinshit(char *niq, char *uh)
{
	char *theuh;
	ShitList *thisptr = shitlist_list;

	if (!uh || !niq)
		return NULL;
	theuh = (char *) new_malloc(strlen(niq)+strlen(uh)+4);
	sprintf(theuh, "*%s", uh);
	while (thisptr)
	{
		if (thisptr->filter && (wild_match(theuh, thisptr->filter) || wild_match(thisptr->filter, theuh))) {
			new_free(&theuh);
			return(thisptr);
		}
		thisptr = thisptr->next;
	}
	new_free(&theuh);
	return NULL;
}

int find_user_level(char *from, char *host, char *channel)
{
UserList * tmp = user_list;
	if (!tmp)
		return 0;
	tmp = (UserList *) nickinuser(from, host);
	if (!tmp)
		return 0;
	if (check_channel_match(tmp->channels, channel))
		return tmp->level;
	return 0;
}

int find_shit_level(char *from, char *host, char *channel)
{
ShitList * tmp = shitlist_list;
	if (!shitlist_list)
		return 0;
	tmp = (ShitList *) nickinshit(from, host);
	if (!tmp)
		return 0;
	if (check_channel_match(tmp->channels, channel))
		return tmp->level;
	return 0;
}

void reload_save(char *command, char *args, char *subargs)
{
char *p = NULL;
char *buffer = NULL;
	if (get_string_var(CTOOLZ_DIR_VAR))
	{
		malloc_sprintf(&buffer, "%s", get_string_var(CTOOLZ_DIR_VAR));
		p = expand_twiddle(buffer);
		if (access(p, F_OK) != 0)
		{
			bitchsay("Created directory %s", p);
			mkdir(p, S_IWUSR|S_IRUSR);
		}
		new_free(&p);
		malloc_sprintf(&buffer, "%s/%s.sav", get_string_var(CTOOLZ_DIR_VAR), version);
	}
	else
		malloc_sprintf(&buffer, "~/%s.sav", version);
	p = expand_twiddle(buffer);
	load(empty_string, p, empty_string); /*CDE XXX p */
	new_free(&buffer);
	new_free(&p);
}

void savelists(char *command, char *args, char *subargs)
{
	char thefile[BIG_BUFFER_SIZE+1];
	char *p = NULL;
	FILE *outfile;
	ShitList *slist = shitlist_list;
	UserList *ulist = user_list;
	AJoinList *ajoin = ajoin_list;

	int count = 0;
	sprintf(thefile, "%s/%s.sav", get_string_var(CTOOLZ_DIR_VAR), version);
	p = expand_twiddle(thefile);
	outfile = fopen(p, "w");
	if (!outfile)
	{
		bitchsay("Cannot open file %s for saving!", thefile);
		new_free(&p);
		return;
	}
	if (do_hook(SAVEFILEPRE_LIST, "%s %s", thefile, p)) 
		bitchsay("Saving All Your Settings to %s", thefile);

	if (ulist)
		fprintf(outfile, "# %s UserList\n", version);
	count = 0;
        while(ulist)
        {
                fprintf(outfile, "ADDUSER %s!%s %s %d %d %d %s\n", ulist->nick, ulist->host, ulist->channels, ulist->level, ulist->aop, ulist->prot, ulist->password? ulist->password : "");
                ulist = ulist->next;
		count ++;
        }
	if (do_hook(SAVEFILE_LIST, "UserList %d", count)) 
	        bitchsay("Saved %d UserList entries", count);

	count = 0;
	if (slist)
		fprintf(outfile, "# %s ShitList\n", version);
        while(slist)
        {
                fprintf(outfile, "ADDSHIT %s!%s %s %d %s\n", slist->filter, slist->filter, slist->channels, slist->level, slist->reason? slist->reason : "");
                slist = slist->next;
		count ++;
        }
	if (do_hook(SAVEFILE_LIST, "ShitList %d", count)) 
	        bitchsay("Saved %d ShitList entries", count);

	if (ajoin)
		fprintf(outfile, "# %s Auto-Join List\n", version);
	count = 0;
        while (ajoin)
        {
         	if (ajoin->ajoin_list == 1) /* actual auto-join entry */
         	{
	                fprintf(outfile, "AJOIN %s\n", ajoin->name ? ajoin->name: "");
			count ++;
		}
       	        ajoin = ajoin->next;
        }
	if (do_hook(SAVEFILE_LIST, "AutoJoin %d", count)) 
	        bitchsay("Saved %d AutoJoin entries", count);

	save_bot(outfile);
	save_notify(outfile);
	save_idle(outfile);
	save_variables(outfile, 1);

	if (awaymsg)
		fprintf(outfile, "ENV AWAYMSG %s\n", awaymsg);
	if (do_hook(SAVEFILEPOST_LIST, "%s %s", thefile, p))
		bitchsay("Done Saving to file %s", thefile);
	
	fclose(outfile);
	new_free(&p);
}

int real_check_auto _((void *arg))
{
	char *nick, *host, *channel;
	char *p = (char *)arg;
	char *args = (char *)arg;
	
	channel = next_arg(args, &args);
	nick = next_arg(args, &args);
	host = next_arg(args, &args);
	
	if (channel && *channel && nick && *nick && host && *host)
	{
		check_auto(channel, nick, host);
	}
	
	new_free(&p);
	return 0;
}

int delay_check_auto _((char *channel))
{
	ChannelList *chan = NULL;
	char *buffer;
	NickList *possible;	
	if (!channel || !*channel)
		return -1;
		
	if ((chan = lookup_channel(channel, from_server, CHAN_NOUNLINK)) == NULL)	
		return -1;

	for (possible = chan->nicks; possible; possible = possible->next)
	{
		if (possible->shitlist || possible->userlist || possible->botlist)		
		{
			buffer = NULL;
			malloc_sprintf(&buffer, "%s %s %s", channel, possible->nick, possible->host);
			add_timer(-1, 3, real_check_auto, buffer, NULL);
		}
	}
	return 0;
}

int delay_opz _((void *arg))
{
char * args = (char *)arg;
char * from = NULL;
char * channel = NULL;	
char *p = (char *) arg; /* original args unmodified  so we can free them */

	channel = next_arg(args, &args);
	from = next_arg(args, &args);
	if (is_chanop(channel, from) == 0 && is_on_channel(channel, from_server, from) && is_chanop(channel, nickname)) 
	{
		send_to_server("MODE %s +o %s", channel, from); 
		send_to_server("NOTICE %s :You have been delay Auto-op'd", from);
	}
	new_free(&p);
	return 0;
}

void check_auto(char *channel, char *nick, char *host)
{

ShitList *shitptr = NULL;
UserList *userptr = NULL, *botptr = NULL;
NickList *nicklist = NULL;
ChannelList *chan_ptr =  NULL;

	if (!channel || !*channel || !are_you_opped(channel) || !nick || !host)
		return;
	
/*
	shitptr = nickinlist(shitlist_list, nick, host);
	userptr = nickinlist(user_list, nick, host);
	botptr = nickinlist(Bot_list, nick, host);
*/
	chan_ptr = (ChannelList *) find_in_list((List **)&(server_list[from_server].chan_list), channel, 0);
	nicklist = (NickList *)find_in_list((List **)&chan_ptr->nicks, nick, 0);
	if (!nicklist)
		return;	

	userptr = nicklist->userlist;
	shitptr = nicklist->shitlist;
	botptr	= nicklist->botlist;

	if (userptr && !check_channel_match(userptr->channels, channel))
		userptr = NULL;
	if (botptr && !check_channel_match(botptr->channels, channel))
		botptr = NULL;
	if (shitptr && !check_channel_match(shitptr->channels, channel))
		shitptr = NULL;
		
	if (cget_int_var(SHITLIST_VAR, channel) && (shitptr != NULL) && (userptr == NULL && botptr == NULL))
	{
		char *theshit;
		theshit = get_string_var(SHITLIST_REASON_VAR);
		if (nicklist)
		{
			if (nicklist->sent_deop > 10)
				return;
			nicklist->sent_deop++;
			nicklist->sent_deop_time = time(NULL);
		}
		switch(shitptr->level)
		{
		
			case 0:
				return;
				break;
			case 1:/* never give opz */
				send_to_server("MODE %s -o %s", channel, nick);
				break;				
			case 2: /* Auto Kick  offender */
				send_to_server("KICK %s %s :%s", channel,
					nick, (shitptr->reason && *shitptr->reason) ? shitptr->reason : theshit);
				break;
			case 3: /* kick ban the offender */
			case 4:	/* perm ban on offender */
				send_to_server("MODE %s -o+b %s %s", channel, nick, nick, shitptr->filter);
				send_to_server("KICK %s %s :%s", channel,
					nick, (shitptr->reason && *shitptr->reason) ? shitptr->reason : theshit);
			default:
				break;
		}
		return;
	} 
	if (get_int_var(AOP_VAR) && cget_int_var(USERLIST_VAR, channel) && (userptr || botptr)) 
	{	
		char *buffer = NULL;
		UserList *user = userptr;
		if (!user && botptr)
			user = botptr;
		switch (user->aop)
		{
			case 1:
				malloc_sprintf(&buffer, "%s %s", channel, nick);
				if (is_chanop(channel, nick) == 0)
					add_timer(-1, 10, delay_opz, buffer, NULL);
				break;
			case 2:
				malloc_sprintf(&buffer, " MODE %s +o %s", channel, nick);
				if (is_chanop(channel, nick) == 0)
					send_to_server(buffer+1);
				new_free(&buffer);
			case 0:
			default:
				break;
		}
		return;
	}
}

void check_hack(char *nick, ChannelList *channel, NickList *ThisNick, char *from)
{
UserList *userptr = NULL, *botptr = NULL;
NickList *Nick;
int	flag;

	if (from && !strchr(from, '.'))
		return;

	if (!channel || !are_you_opped(channel->channel) || !nick || !ThisNick || wild_match(nick, get_server_nickname(from_server)))
		return;

	if (!(flag = cget_int_var(HACKING_CVAR, channel->channel)))
		return;

	if (ThisNick->sent_deop && (time(NULL) - ThisNick->sent_deop_time < 10))
		return;

	Nick = (NickList *)find_in_list((List **)&channel->nicks, nick, 0);
	if (Nick)
	{
		userptr = Nick->userlist;
		botptr = Nick->botlist;
	}

	if ( (!userptr && !botptr) || (userptr && !check_channel_match(userptr->channels, channel->channel)) ||
		(botptr && !check_channel_match(botptr->channels, channel->channel)))
	{
		switch(flag)
		{
			case 1:
			case 3:
				if (is_chanop(channel->channel, nick))
					send_to_server("MODE %s -o %s", channel->channel, nick);
				ThisNick->sent_deop++;
				ThisNick->sent_deop_time = time(NULL);
			case 2:
				if (flag != 1)
					bitchsay("NetHack detected on %s by %s!%s", channel->channel, nick, ThisNick->host); 
			case 0:
			default:
				break;
		}
	}
}

/*
 *  Protection levels
 *  1 Reop if de-oped
 *  2 De-op offender
 *  3 Kick  offender
 *  4 KickBan offender
 */
int check_prot(char *from, char *person, ChannelList *chan)
{
NickList *tmp;

	if (!from || !*from || !person || !*person || !chan)
		return 0;
	tmp = (NickList *)list_lookup((List **)&chan->nicks, person, !USE_WILDCARDS, !REMOVE_FROM_LIST);
	if (tmp && (tmp->userlist || tmp->botlist))
	{
		UserList *user = tmp->userlist;		
		if (!user)
			user = tmp->botlist;		
		if (!user || (user && !check_channel_match(user->channels, chan->channel)))
			return 0;
		switch(user->prot)
		{
			case 1:
			{
				if (!tmp->sent_reop)
				{
					send_to_server("MODE %s +o %s", chan->channel, tmp->nick);
					tmp->sent_reop++;
					tmp->sent_reop_time = time(NULL);
				}
				break;
			}
			case 2:
			{
				send_to_server("MODE %s -o %s", chan->channel, from);
				tmp->sent_deop++;
				tmp->sent_deop_time = time(NULL);
				break;
			}
			case 4:
			{
				send_to_server("MODE %s -o+b %s", chan->channel, from);
			}
			case 3:
			{
				send_to_server("KICK %s %s :Protected User", chan->channel, from);
				break;
			}
			default:
				break;
		}
		return 1;
	}
	return 0;
}

void change_user(char *command, char *args, char *subargs)
{
int comm = 0;
char *user, *what;
	if (!my_stricmp(command, "CHGLEVEL"))
		comm = 1;
	else if (!my_stricmp(command, "CHGPROT"))
		comm = 2;
	else if (!my_stricmp(command, "CHGCHAN"))
		comm = 3;
	else if (!my_stricmp(command, "CHGAUTOOP"))
		comm = 4;
	if (comm && (user = next_arg(args, &args)) && (what = next_arg(args, &args)))
	{
		UserList *ThisNick;
		int prot, level, autoop;
		char *channels = NULL;
		char *password = NULL;
		if (!(ThisNick = (UserList *)remove_from_list((List **)&user_list, user)))
		{
			bitchsay("Nick %s was not found", user);
			return;
		}	
		prot = ThisNick->prot;
		level = ThisNick->level;
		autoop = ThisNick->aop;
		channels = ThisNick->channels;
		password = ThisNick->password;					

		switch(comm)
		{
			case 1:
				level = atoi(what);
				break;
			case 2:
				prot = atoi(what);
				break;
			case 3:
				ThisNick->channels = NULL;
				malloc_strcpy(&channels, what);
				break;
			case 4:
				autoop = atoi(what);
				break;
			default:
				break;
		}
		if (password)
			add_to_userhost_queue(ThisNick->nick, prepare_userhost, "%d %d %d %d 0 %s %s", USERLIST_MOD, level, autoop, prot, channels, password);
		else
			add_to_userhost_queue(ThisNick->nick, prepare_userhost, "%d %d %d %d 0 %s", USERLIST_MOD, level, autoop, prot, channels);
		new_free(&ThisNick->nick);
		new_free(&ThisNick->host);
		new_free(&ThisNick->channels);
		new_free(&ThisNick->password);
		new_free((char **)&ThisNick);
	}		
	else
		bitchsay("%s: nick what", command);

	return;
}
